﻿
namespace ProjectGasolineTanker.Drawings;
/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>

public class DrawingTruckCompareByColor : IComparer<DrawingTruck?>
{
    public int Compare(DrawingTruck? x, DrawingTruck? y)
    {
        
        if (x == null || x.EntityTruck == null)
        {
            return 1;
        }

        if (y == null || y.EntityTruck == null)
        {
            return -1;
        }

        var bodycolorCompare = x.EntityTruck.BodyColor.Name.CompareTo(y.EntityTruck.BodyColor.Name);

        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }

        var speedCompare = x.EntityTruck.Speed.CompareTo(y.EntityTruck.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTruck.Weight.CompareTo(y.EntityTruck.Weight);
    }
}

