﻿namespace ProjectGasolineTanker.Drawings;

/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawingTruckCompareByType : IComparer<DrawingTruck?>
{
    public int Compare(DrawingTruck? x, DrawingTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return 1;
        }

        if (y == null || y.EntityTruck == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityTruck.Speed.CompareTo(y.EntityTruck.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTruck.Weight.CompareTo(y.EntityTruck.Weight);
    }
}

