﻿
using ProjectGasolineTanker.Entities;
using System.Diagnostics.CodeAnalysis;

namespace ProjectGasolineTanker.Drawings;

public class DrawingTruckEqutables : IEqualityComparer<DrawingTruck?>
{
   
    public bool Equals(DrawingTruck? x, DrawingTruck? y)
    {
        if (x == null || x.EntityTruck == null)
        {
            return false;
        }

        if (y == null || y.EntityTruck == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityTruck.Speed != y.EntityTruck.Speed)
        {
            return false;
        }

        if (x.EntityTruck.Weight != y.EntityTruck.Weight)
        {
            return false;
        }

        if (x.EntityTruck.BodyColor != y.EntityTruck.BodyColor)
        {
            return false;
        }

        if (x is DrawingGasolineTanker && y is DrawingGasolineTanker)
        {
            // логика сравнения дополнительных параметров
            if ((x.EntityTruck as EntityGasolineTanker).AdditionalColor != (y.EntityTruck as EntityGasolineTanker).AdditionalColor)
            {
                return false;
            }
            if ((x.EntityTruck as EntityGasolineTanker).SignalBeacon != (y.EntityTruck as EntityGasolineTanker).SignalBeacon)
            {
                return false;
            }
            if ((x.EntityTruck as EntityGasolineTanker).GasTank != (y.EntityTruck as EntityGasolineTanker).GasTank)
            {
                return false;
            }
            
           
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawingTruck obj)
    {
        return obj.GetHashCode();
    }

  
}
